
/***********************************************************************
* Copyright 1998-2020 CERN for the benefit of the EvtGen authors       *
*                                                                      *
* This file is part of EvtGen.                                         *
*                                                                      *
* EvtGen is free software: you can redistribute it and/or modify       *
* it under the terms of the GNU General Public License as published by *
* the Free Software Foundation, either version 3 of the License, or    *
* (at your option) any later version.                                  *
*                                                                      *
* EvtGen is distributed in the hope that it will be useful,            *
* but WITHOUT ANY WARRANTY; without even the implied warranty of       *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
* GNU General Public License for more details.                         *
*                                                                      *
* You should have received a copy of the GNU General Public License    *
* along with EvtGen.  If not, see <https://www.gnu.org/licenses/>.     *
***********************************************************************/

#ifndef EVTPARSER_HH
#define EVTPARSER_HH

#include <string>

class EvtParser {
  public:
    EvtParser();
    ~EvtParser();

    int read( const std::string filename );
    int getNToken();
    const std::string& getToken( int i );
    int getLineofToken( int i );

  private:
    int _ntoken;
    std::string* _tokenlist;
    int* _linelist;
    int _lengthoftokenlist;

    void addToken( int line, const std::string& string );
};

#endif
